package com.smith9.geiger.client

import groovy.xml.MarkupBuilder

import com.smith9.geiger.client.beans.Stat
import com.smith9.geiger.client.beans.Duration

/**
 * Created: 7/03/12
 * @author david
 */
class DurationConverter implements LoaderConverter {
    String toXml(List<Stat> stats) {
        StringWriter writer = new StringWriter()
        MarkupBuilder builder = new MarkupBuilder(writer)
        builder.durations() {
            stats.each { durationNode ->
                duration(toMap(durationNode)) {
                    metadata(durationNode.metadata)
                }
            }
        }
        return writer.toString()
    }

    static Map<String, String> toMap(Duration duration) {
        assert duration.startTime, "StartTime is mandatory"
        assert duration.measure, "measure is mandatory"
        Map<String, String> properties = [:]
        properties.put("environment", duration.environment)
        properties.put("productName", duration.product)
        properties.put("subProduct", duration.subProduct)
        properties.put("startTime", duration.startTime.toString("yyyy-MM-dd HH:mm:ss.SSS"))
        properties.put("duration", duration.duration)
        properties.put("measure", duration.measure)
        properties.put("grouping", duration.grouping)
        properties.put("reference", duration.reference)
        properties.put("batch", duration.batch)
        properties.put("batchType", duration.batchType)
        properties.put("failure", duration.failure)
        return properties
    }

    String getLoadMethod() {
        return "duration"
    }
}
